from tkinter import *
from tkinter import ttk

class PresentationLayer():
	def __init__(self, parser, name_var, address_var, input_chunk_var):
		self.top_parser = parser
		self.top_parser_name = name_var
		self.top_parser_address = address_var
		self.input_chunk = input_chunk_var

	def set_top_parser(self,parser):
		self.top_parser = parser
		self.top_parser_name.set(self.top_parser.name)
		self.top_parser_address.set(hex(self.top_parser.address))

	def set_input_chunk(self, input_chunk):
		self.input_chunk.set(input_chunk)

def step(*args):
	gdb.execute("hammer-parse-step 1")
	presentation_layer.set_top_parser(top_level_parse.peek_parser())
	presentation_layer.set_input_chunk(top_level_parse.get_input_chunk())

if top_level_parse is None:
	print("Please import parser name script")
else:
	root = Tk()
	root.title("Parser visualization")

	frame = ttk.Frame(root, padding="12 12 12 12")
	frame.grid(column=0, row=0, sticky=(N, W, E, S))
	root.columnconfigure(0, weight=1)
	root.rowconfigure(0, weight=1)

	parser = StringVar() # TODO: encapsulate variables to avoid namespace pollution
	parser_addr = StringVar()
	input_chunk = StringVar()
	presentation_layer = PresentationLayer(top_level_parse.peek_parser(), parser, parser_addr, input_chunk)
	presentation_layer.set_top_parser(top_level_parse.peek_parser())
	presentation_layer.set_input_chunk(top_level_parse.get_input_chunk())
	#presentation_layer.top_parser_name = parser
	#presentation_layer.top_parser_addr = parser_addr
	#presentation_layer.top_parser = top_level_parse.peek_parser()
	#presentation_layer.set_top_parser(top_level_parse.peek_parser())

	#presentation_layer.top_parser = top_level_parse.peek_parser()
	ttk.Label(frame, textvariable=presentation_layer.top_parser_name).grid(column=1, row=1)
	#ttk.Label(frame, text="Placeholder name").grid(column=1, row=1)
	ttk.Label(frame, textvariable=presentation_layer.top_parser_address).grid(column=1, row=2)
	#ttk.Label(frame, text="Placeholder address").grid(column=1, row=2)
	ttk.Label(frame, textvariable=presentation_layer.input_chunk).grid(column=2, row=1)
	ttk.Button(frame, text="Step", command=step).grid(column=1, row=3)

	root.mainloop()

