# These need to be constructed in HDoParseBreakpoint (or at least in a scope where 'parser' is visible)
# TODO: these can learn of parsers before the parser name instrumentation does
# TopLevelParse should be amenable to adding parsers to the dict through here


class SequenceEnv:
	def __init__(self, parser, top_level_parse)
		self.parser = parser
		self.member_parsers = []

		frame = gdb.selected_frame()
		h_sequence_p = gdb.parse_and_eval("(HSequence*) parser->env")
		num_parsers = gdb.parse_and_eval("((HSequence *) parser->env)->len")
		# TODO: should GDB do the array indexing operation, or should the Python code?
		# TODO: top_level_parse.create_or_get_parser(address)
		#[gdb.parse_and_eval("((HSequence*) parser->env)->p_array[" + str(index) + "]") for index in range(0, num_parsers)]

		for index in xrange(0, num_parsers):
			parser_p = gdb.parse_and_eval("((HSequence*) parser->env)->p_array[" + str(index) + "]")
			try:
				parser_obj = top_level_parse.parser_objs[int(parser_p)]
			except KeyError:
				parser_obj = Parser(None, int(parser_p))
				top_level_parse.parser_objs[int(parser_p)] = parser_obj
			self.member_parsers.append(parser_obj)

		# TODO


class IgnoreEnv:
	def __init__(self, parser, top_level_parse):
		self.parser = parser
		self.member_parser_pointers = []

		ignored_p = gdb.parse_and_eval("(HParser*) parser->env")

		# Ideally we could look up ignored_p using top_level_parse, but it will not find a result if perform_lowlevel_parse(ignored_p) wasn't called yet
		#TODO: method to add parser in TopLevelParse

		'''
		try:
			parser_obj = top_level_parse.parser_objs[ignored_p]
		except KeyError:
			# Create a parser object with no name and the address of the parser
			parser_obj = Parser(None, int(ignored_p))
			top_level_parse.parser_objs[int(ignored_p)] = parser_obj

		self.member_parsers.append(parser_obj)
		'''
		self.member_parsers.append(ignored_p)

